SystemOrganization addCategory: #'TxText-Athens'!

Object subclass: #TxAthensLayout
	instanceVariableNames: 'interval extent lines'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-Athens'!

!TxAthensLayout commentStamp: '<historical>' prior: 0!
i represent the cached visual layout of given text!

!TxAthensLayout methodsFor: 'scanning' stamp: 'IgorStasenko 8/8/2013 17:12'!
addLine: newLine

	lines add: newLine.
	extent := (extent x max: newLine width) @ extent y + newLine height! !

!TxAthensLayout methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 17:10'!
endPosition
	^ interval end! !

!TxAthensLayout methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 17:09'!
extent
	^ extent! !

!TxAthensLayout methodsFor: 'initialize-release' stamp: 'IgorStasenko 8/8/2013 03:18'!
initialize
	lines := OrderedCollection new.
	extent := 0@0.! !

!TxAthensLayout methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 17:09'!
interval
	^ interval! !

!TxAthensLayout methodsFor: 'accessing' stamp: 'IgorStasenko 8/6/2013 18:16'!
interval: anInterval
	interval := anInterval! !

!TxAthensLayout methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 18:08'!
lines
	^ lines! !

!TxAthensLayout methodsFor: 'scanning' stamp: 'IgorStasenko 8/8/2013 17:11'!
scanLineUsing: strategy

	| newLine end |
	interval end isAtEnd ifTrue: [  ^ self  ]. "nothing left to scan"
	end := interval end.
	
	newLine := TxAthensLayoutLine new.
	strategy scanLine: newLine startingFrom: end.
	interval end: newLine endPosition.
	
	self addLine: newLine! !

!TxAthensLayout methodsFor: 'accessing' stamp: 'IgorStasenko 8/6/2013 18:25'!
startPosition
	^ interval start! !

Object subclass: #TxAthensLayoutLine
	instanceVariableNames: 'interval commands width height baselineOffset maxAscent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-Athens'!

!TxAthensLayoutLine methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/12/2013 15:24'!
accumulateAscent: asc
	maxAscent := maxAscent max: asc! !

!TxAthensLayoutLine methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 17:56'!
accumulateHeight: h
	height := height max: h! !

!TxAthensLayoutLine methodsFor: 'accessing' stamp: 'IgorStasenko 8/12/2013 15:33'!
addCommand: cmd

	commands add: cmd
	! !

!TxAthensLayoutLine methodsFor: 'scanning' stamp: 'IgorStasenko 8/8/2013 17:07'!
addWidth: aNumber 
	width := width + aNumber! !

!TxAthensLayoutLine methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 16:36'!
baselineOffset
	^ baselineOffset! !

!TxAthensLayoutLine methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 03:19'!
commands
	
	^ commands! !

!TxAthensLayoutLine methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 16:39'!
endPosition
	^ interval end ! !

!TxAthensLayoutLine methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 16:35'!
endPosition: aTxTextPosition 
	interval 
		ifNil: [ interval := (aTxTextPosition to: aTxTextPosition) beSelection ]
		ifNotNil: [  interval end: aTxTextPosition ]! !

!TxAthensLayoutLine methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 16:36'!
height
	^ height! !

!TxAthensLayoutLine methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 16:36'!
height: anObject
	height := anObject! !

!TxAthensLayoutLine methodsFor: 'initalize-release' stamp: 'IgorStasenko 8/12/2013 15:23'!
initialize
	super initialize.
	maxAscent := height := baselineOffset := width := 0.
	commands := OrderedCollection new! !

!TxAthensLayoutLine methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 03:19'!
interval
	
	^ interval! !

!TxAthensLayoutLine methodsFor: 'accessing' stamp: 'IgorStasenko 8/12/2013 15:22'!
maxAscent
	^ maxAscent! !

!TxAthensLayoutLine methodsFor: 'rendering' stamp: 'IgorStasenko 8/19/2013 16:04'!
renderOn: aTxTextRenderer 
	
	aTxTextRenderer canvas 
		setPaint: Color red;
		drawShape: (0@ maxAscent negated corner: width@(maxAscent negated+height)).
	
	commands do: [:cmd | cmd renderOn: aTxTextRenderer ]! !

!TxAthensLayoutLine methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 16:34'!
startPosition: aTxTextPosition 
	interval 
		ifNil: [ interval := (aTxTextPosition to: aTxTextPosition) beSelection ]
		ifNotNil: [  interval start: aTxTextPosition ]! !

!TxAthensLayoutLine methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 16:36'!
width
	^ width! !

!TxAthensLayoutLine methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 16:36'!
width: anObject
	width := anObject! !

Object subclass: #TxAthensLayoutStrategy
	instanceVariableNames: 'start view layout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-Athens'!

!TxAthensLayoutStrategy methodsFor: 'building' stamp: 'IgorStasenko 8/8/2013 17:10'!
computeLayoutFor: aView position: aStartingPosition 

	start := aStartingPosition copy moveToLineStart.
	view := aView.
	
	layout := TxAthensLayout new 
		interval:  (start to: start) beSelection.
	
	"scan lines of text until its enough for current view, or there's nothing left to scan"
	[ layout scanLineUsing: self. 
		(layout extent y <= view extent y) and: [ layout endPosition isAtEnd not ] ] whileTrue.
	
	^ layout! !

!TxAthensLayoutStrategy methodsFor: 'scanning' stamp: 'IgorStasenko 8/8/2013 03:13'!
scanLine: aTxLayoutLine
	"scan the text line, until strategy conditions are met"
	
	self subclassResponsibility! !

!TxAthensLayoutStrategy methodsFor: 'scanning' stamp: 'IgorStasenko 8/8/2013 03:43'!
scanLine: aTxLayoutLine startingFrom: aLineStart
	"scan the text line, until strategy conditions are met"
	
	self subclassResponsibility! !

TxAthensLayoutStrategy subclass: #TxAthensNoWrapStrategy
	instanceVariableNames: 'finished currentLine'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-Athens'!

!TxAthensNoWrapStrategy methodsFor: 'visiting' stamp: 'IgorStasenko 8/19/2013 16:50'!
getWidthOf: char font: aFont 
	| slot |
	slot := SimpleTextGlyphInfo new.
	
	! !

!TxAthensNoWrapStrategy methodsFor: 'scanning' stamp: 'IgorStasenko 8/8/2013 04:04'!
scanLine: line startingFrom: aLineStart
	"Scan the text line, until strategy conditions are met.
	No-wrap strategy ends scanning only when it meets the line end (or text end)"
	| span |
	
	currentLine := line.
	line 
		startPosition: aLineStart; 
		endPosition: aLineStart copy.
	
	span := aLineStart span.
	finished := false.
	[ span accept: self. finished ] whileFalse: [ 
		span := span nextIfNone: [  ^ self ].
		line endPosition: span startPosition.
	].! !

!TxAthensNoWrapStrategy methodsFor: 'visiting' stamp: 'IgorStasenko 8/22/2013 15:09'!
visitCharacterSpan: aSpan
	
	| chars startPos font w  fontMetricsProvider |
	
	chars := aSpan characters.
	
	startPos := currentLine endPosition spanPosition.
	startPos = 0 ifTrue: [  startPos := 1 ].
	
	
	font := aSpan getAttribute: TxFontAttribute.  
	
	fontMetricsProvider := view fontMetricsProviderFor: font.
	currentLine accumulateHeight: fontMetricsProvider fontHeight.
	currentLine accumulateAscent: fontMetricsProvider fontAscent.
	
	w := 0.
	startPos to: chars size do: [ :i |
			w := w + (fontMetricsProvider getGlyphWidth: (chars at:i))
	].
	currentLine addWidth: w.

	currentLine addCommand: (TxCharacterSpanDisplayCommand new span: aSpan;
		start: startPos; stop: aSpan size; advance: w@0; yourself).
		
	! !

!TxAthensNoWrapStrategy methodsFor: 'visiting' stamp: 'IgorStasenko 8/8/2013 03:59'!
visitEndSpan: aSpan

	finished := true.
	currentLine endPosition: aSpan startPosition.
	! !

!TxAthensNoWrapStrategy methodsFor: 'visiting' stamp: 'IgorStasenko 8/8/2013 17:32'!
visitLineSeparator: aSpan

	finished := true.
	currentLine endPosition: aSpan next startPosition.
	! !

!TxAthensNoWrapStrategy methodsFor: 'visiting' stamp: 'IgorStasenko 8/8/2013 03:59'!
visitStartSpan: aSpan

	"do nothing"! !

Object subclass: #TxAthensLayoutView
	instanceVariableNames: 'extent layoutStrategy layout text offset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-Athens'!

!TxAthensLayoutView class methodsFor: 'instance creation' stamp: 'IgorStasenko 8/6/2013 17:57'!
on: aTxModel extent: aPoint
	^ self new
		text: aTxModel;
		InitWithExtent: aPoint! !

!TxAthensLayoutView methodsFor: 'initializing' stamp: 'IgorStasenko 8/6/2013 17:56'!
InitWithExtent: aPoint
	
	
	^ self InitWithStrategy: self defaultStrategy position: text startPosition extent: aPoint! !

!TxAthensLayoutView methodsFor: 'initializing' stamp: 'IgorStasenko 8/6/2013 17:54'!
InitWithPosition: aStartPosition extent: aPoint
	
	
	^ self InitWithStrategy: self defaultStrategy position: aStartPosition extent: aPoint! !

!TxAthensLayoutView methodsFor: 'initializing' stamp: 'IgorStasenko 8/6/2013 18:25'!
InitWithStrategy: aLayoutStrategy position: aStartPosition extent: aPoint
	
	offset := 0@0.
	layoutStrategy := aLayoutStrategy.
	extent := aPoint.
	
	layout := layoutStrategy computeLayoutFor: self position: aStartPosition! !

!TxAthensLayoutView methodsFor: 'defaults' stamp: 'IgorStasenko 8/8/2013 16:31'!
defaultStrategy
	^ TxAthensNoWrapStrategy new! !

!TxAthensLayoutView methodsFor: 'accessing' stamp: 'IgorStasenko 8/5/2013 17:25'!
extent
	^ extent! !

!TxAthensLayoutView methodsFor: 'accessing' stamp: 'IgorStasenko 8/6/2013 17:39'!
extent: aPoint 
	extent := aPoint.
	! !

!TxAthensLayoutView methodsFor: 'accessing' stamp: 'IgorStasenko 8/22/2013 13:35'!
fontMetricsProviderFor: aFont
	^ CairoFontMetricsProvider new 
			font: aFont;
			yourself ! !

!TxAthensLayoutView methodsFor: 'initializing' stamp: 'IgorStasenko 8/22/2013 13:36'!
initialize

	offset := 0@0.
	! !

!TxAthensLayoutView methodsFor: 'accessing' stamp: 'IgorStasenko 8/6/2013 18:12'!
layout
	^ layout! !

!TxAthensLayoutView methodsFor: 'accessing' stamp: 'IgorStasenko 8/6/2013 17:41'!
layoutStrategy
	^ layoutStrategy! !

!TxAthensLayoutView methodsFor: 'accessing' stamp: 'IgorStasenko 8/6/2013 17:41'!
layoutStrategy: anObject
	layoutStrategy := anObject! !

!TxAthensLayoutView methodsFor: 'accessing' stamp: 'IgorStasenko 8/6/2013 14:46'!
offset
	^ offset! !

!TxAthensLayoutView methodsFor: 'accessing' stamp: 'IgorStasenko 8/5/2013 18:00'!
positionAt: aPoint 
	"calculate the text position at given point"
	^ text startPosition! !

!TxAthensLayoutView methodsFor: 'rendering' stamp: 'IgorStasenko 8/12/2013 15:20'!
renderOn: canvas

	"
	set up clipping
	- draw line by line
	"
	| renderer |

	renderer := TxTextRenderer new.
	renderer renderLines: layout lines on: canvas.
	
! !

!TxAthensLayoutView methodsFor: 'initializing' stamp: 'IgorStasenko 8/12/2013 15:26'!
resetLayout
	
	layout := layoutStrategy computeLayoutFor: self position: layout startPosition! !

!TxAthensLayoutView methodsFor: 'accessing' stamp: 'IgorStasenko 8/5/2013 17:24'!
text: aTxModel 
	text := aTxModel! !

Object subclass: #TxAthensRenderingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-Athens'!

!TxAthensRenderingTest class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/22/2013 14:34'!
test
	| text view  sceneView sel |
	text := TxAthensLayoutTest new newText.
	
	sel := text select all.
	sel end 
		moveToStart;
		moveRight: 20.
	sel
		applyAttribute: (TxFontAttribute with: (LogicalFont familyName: 'Tahoma'
 pointSize: 20)).
	
	view := TxAthensLayoutView on:text extent:100@200.
	
	sceneView := AthensSceneView new scene: view.
	^ sceneView openInWindow.
! !

Object subclass: #TxDisplayCommand
	instanceVariableNames: 'next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-Athens'!

TxDisplayCommand subclass: #TxCharacterSpanDisplayCommand
	instanceVariableNames: 'span start stop advance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-Athens'!

!TxCharacterSpanDisplayCommand methodsFor: 'accessing' stamp: 'IgorStasenko 8/22/2013 15:08'!
advance
	
	^ advance! !

!TxCharacterSpanDisplayCommand methodsFor: 'accessing' stamp: 'IgorStasenko 8/22/2013 15:08'!
advance: anObject
	
	advance := anObject! !

!TxCharacterSpanDisplayCommand methodsFor: 'rendering' stamp: 'IgorStasenko 8/22/2013 15:10'!
renderOn: renderer

	renderer setFont: (span getAttribute: TxFontAttribute).
	renderer setColor: (span getAttribute: TxForeColorAttribute).
	
	renderer renderCharacters: span characters from: start to: stop.
	renderer advance:advance.! !

!TxCharacterSpanDisplayCommand methodsFor: 'accessing' stamp: 'IgorStasenko 8/12/2013 15:31'!
span
	^ span! !

!TxCharacterSpanDisplayCommand methodsFor: 'accessing' stamp: 'IgorStasenko 8/12/2013 15:31'!
span: anObject
	span := anObject! !

!TxCharacterSpanDisplayCommand methodsFor: 'accessing' stamp: 'IgorStasenko 8/12/2013 15:31'!
start
	^ start! !

!TxCharacterSpanDisplayCommand methodsFor: 'accessing' stamp: 'IgorStasenko 8/12/2013 15:31'!
start: anObject
	start := anObject! !

!TxCharacterSpanDisplayCommand methodsFor: 'accessing' stamp: 'IgorStasenko 8/12/2013 15:31'!
stop
	^ stop! !

!TxCharacterSpanDisplayCommand methodsFor: 'accessing' stamp: 'IgorStasenko 8/12/2013 15:31'!
stop: anObject
	stop := anObject! !

!TxDisplayCommand methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 18:40'!
addLast: aCommand
	self tail next: aCommand! !

!TxDisplayCommand methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 18:40'!
do: aBlock
	| nn |
	nn := self.
	
	[ nn isNil ] whileFalse: [ 
		aBlock value: nn.
		nn := nn next. ]! !

!TxDisplayCommand methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 18:40'!
insert: aCommands

	| nn |
	nn := next.
	next := aCommands.
	next tail next: nn! !

!TxDisplayCommand methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 18:40'!
next

	^ next! !

!TxDisplayCommand methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 18:40'!
next: anObject
	
	next := anObject! !

!TxDisplayCommand methodsFor: 'copying' stamp: 'IgorStasenko 8/8/2013 18:40'!
postCopy
	"unlink the copy by default"
	next := nil! !

!TxDisplayCommand methodsFor: 'rendering' stamp: 'IgorStasenko 8/8/2013 18:40'!
renderOn: renderer
	self shouldBeImplemented ! !

!TxDisplayCommand methodsFor: 'accessing' stamp: 'IgorStasenko 8/8/2013 18:40'!
tail
	| nn |
	nn := self.
	[ nn next notNil ] whileTrue: [ nn := nn next ].
	^ nn! !

Object subclass: #TxTextRenderer
	instanceVariableNames: 'text font canvas glyphRenderer color advance maxAscent currentLine'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-Athens'!

!TxTextRenderer class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/9/2013 15:31'!
textGoryDetails

"
Took from: http://www.freetype.org/freetype2/docs/tutorial/step2.html

(Font face metrics)
In this case, you can access the global design metrics as:

units_per_EM 	

This is the size of the EM square for the font face. It is used by scalable formats to scale design coordinates to device pixels, as described in the last chapter of this section. Its value usually is 2048 (for TrueType) or 1000 (for Type 1), but others are possible too. It is set to 1 for fixed-size formats like FNT/FON/PCF/BDF.

bbox 	

The global bounding box is defined as the largest rectangle that can enclose all the glyphs in a font face.

ascender 	

The ascender is the vertical distance from the horizontal baseline to the highest ‘character’ coordinate in a font face. Unfortunately, font formats define the ascender differently. For some, it represents the ascent of all capital latin characters (without accents), for others it is the ascent of the highest accented character, and finally, other formats define it as being equal to bbox.yMax.

descender 	

The descender is the vertical distance from the horizontal baseline to the lowest ‘character’ coordinate in a font face. Unfortunately, font formats define the descender differently. For some, it represents the descent of all capital latin characters (without accents), for others it is the ascent of the lowest accented character, and finally, other formats define it as being equal to bbox.yMin. This field is negative for values below the baseline.

height 	

This field is simply used to compute a default line spacing (i.e., the baseline-to-baseline distance) when writing text with this font. Note that it usually is larger than the sum of the ascender and descender taken as absolute values. There is also no guarantee that no glyphs extend above or below subsequent baselines when using this distance.

max_advance_width 	

This field gives the maximum horizontal cursor advance for all glyphs in the font. It can be used to quickly compute the maximum advance width of a string of text. It doesn't correspond to the maximum glyph image width!!

max_advance_height 	

Same as max_advance_width but for vertical text layout.

underline_position 	

When displaying or rendering underlined text, this value corresponds to the vertical position, relative to the baseline, of the underline bar's center. It is negative if it is below the baseline.

underline_thickness 	

When displaying or rendering underlined text, this value corresponds to the vertical thickness of the underline.


"! !

!TxTextRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/22/2013 15:21'!
advance: ad
	
	canvas pathTransform translateBy: ad! !

!TxTextRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/19/2013 16:01'!
canvas
	^ canvas! !

!TxTextRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/9/2013 15:31'!
initialize
	color := Color black.! !

!TxTextRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/22/2013 15:16'!
render: aText lines: lines on: aCanvas

	text := aText.
	canvas := aCanvas.
	
	canvas pathTransform restoreAfter: [

		lines do: [:line | |  |
			currentLine := line.
			maxAscent := line maxAscent.
			"set the origin to font's baseline position"
			canvas pathTransform translateX: 220 Y: maxAscent.
			"reset advance"
			advance := 0@0.
			canvas pathTransform restoreAfter: [
				line renderOn: self ].
			"line is rendered, advance vertically by line height"
			canvas pathTransform translateX: 0 Y: line height * 1.2 - maxAscent.
		] ]! !

!TxTextRenderer methodsFor: 'rendering' stamp: 'IgorStasenko 8/22/2013 15:18'!
renderCharacters: aString from: start to: stop 
	

	" accumulate advance while rendering spans"
	"canvas drawShape: (advance x @ advance y extent: 2 @ 2)."
	canvas 
		setPaint: color;
		setFont: font;
		drawString: aString from: start to: stop! !

!TxTextRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/22/2013 15:21'!
renderLines: lines on: aCanvas

	canvas := aCanvas.
	
	canvas pathTransform restoreAfter: [
		"canvas pathTransform rotateByDegrees: 15."
		lines do: [:line | |  |
			currentLine := line.
			maxAscent := line maxAscent.
			"set the origin to font's baseline position"
			canvas pathTransform translateX: 0 Y: maxAscent.
			"reset advance"
			advance := 0@0.
			
			canvas pathTransform restoreAfter: [
				line renderOn: self ].
			
			
			"line is rendered, advance vertically by line height"
			canvas pathTransform translateX: 0 Y: line height - maxAscent.

"			canvas pathTransform translateX: 0 Y: line height * 1.2 - maxAscent."
		] ]! !

!TxTextRenderer methodsFor: 'rendering' stamp: 'IgorStasenko 8/12/2013 16:03'!
setColor: aColor 
	color := aColor.! !

!TxTextRenderer methodsFor: 'rendering' stamp: 'IgorStasenko 8/12/2013 15:39'!
setFont: aFont 
	font := aFont! !

TestCase subclass: #TxAthensLayoutTest
	instanceVariableNames: 'text layout view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-Athens'!

!TxAthensLayoutTest methodsFor: 'instance-creation' stamp: 'IgorStasenko 8/5/2013 17:07'!
newLayoutOn:  aText

	layout := TxAthensLayout new text: aText! !

!TxAthensLayoutTest methodsFor: 'instance-creation' stamp: 'IgorStasenko 8/19/2013 16:34'!
newText

	text := TxModel new.
	
	text endPosition insert: '"Lorem
ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum."
Section 1.10.32 of "de Finibus Bonorum et Malorum", written by Cicero in 45 BC

"Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo. Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit, sed quia consequuntur magni dolores eos qui ratione voluptatem sequi nesciunt. Neque porro quisquam est, qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit, sed quia non numquam eius modi tempora incidunt ut labore et dolore magnam aliquam quaerat voluptatem. Ut enim ad minima veniam, quis nostrum exercitationem ullam corporis suscipit laboriosam, nisi ut aliquid ex ea commodi consequatur? Quis autem vel eum iure reprehenderit qui in ea voluptate velit esse quam nihil molestiae consequatur, vel illum qui dolorem eum fugiat quo voluptas nulla pariatur?"
1914 translation by H. Rackham

"But I must explain to you how all this mistaken idea of denouncing pleasure and praising pain was born and I will give you a complete account of the system, and expound the actual teachings of the great explorer of the truth, the master-builder of human happiness. No one rejects, dislikes, or avoids pleasure itself, because it is pleasure, but because those who do not know how to pursue pleasure rationally encounter consequences that are extremely painful. Nor again is there anyone who loves or pursues or desires to obtain pain of itself, because it is pain, but because occasionally circumstances occur in which toil and pain can procure him some great pleasure. To take a trivial example, which of us ever undertakes laborious physical exercise, except to obtain some advantage from it? But who has any right to find fault with a man who chooses to enjoy a pleasure that has no annoying consequences, or one who avoids a pain that produces no resultant pleasure?"
Section 1.10.33 of "de Finibus Bonorum et Malorum", written by Cicero in 45 BC

"At vero eos et accusamus et iusto odio dignissimos ducimus qui blanditiis praesentium voluptatum deleniti atque corrupti quos dolores et quas molestias excepturi sint occaecati cupiditate non provident, similique sunt in culpa qui officia deserunt mollitia animi, id est laborum et dolorum fuga. Et harum quidem rerum facilis est et expedita distinctio. Nam libero tempore, cum soluta nobis est eligendi optio cumque nihil impedit quo minus id quod maxime placeat facere possimus, omnis voluptas assumenda est, omnis dolor repellendus. Temporibus autem quibusdam et aut officiis debitis aut rerum necessitatibus saepe eveniet ut et voluptates repudiandae sint et molestiae non recusandae. Itaque earum rerum hic tenetur a sapiente delectus, ut aut reiciendis voluptatibus maiores alias consequatur aut perferendis doloribus asperiores repellat."
'.

	^ text! !

!TxAthensLayoutTest methodsFor: 'instance-creation' stamp: 'IgorStasenko 8/6/2013 17:57'!
newView
	view := TxAthensLayoutView on: text extent: 100@100! !

!TxAthensLayoutTest methodsFor: 'running' stamp: 'IgorStasenko 8/6/2013 18:25'!
setUp

	text := self newText.

	self newView. ! !

!TxAthensLayoutTest methodsFor: 'tests' stamp: 'IgorStasenko 8/6/2013 18:22'!
testFreshViewLayoutNotNil
		
	self assert: view layout isNil not ! !

!TxAthensLayoutTest methodsFor: 'tests' stamp: 'IgorStasenko 8/6/2013 18:08'!
testFreshViewOffsetShouldBeZero
	"initially origin should be set to 0@0 "
	
	
	self assert: view offset equals: 0@0! !

!TxAthensLayoutTest methodsFor: 'tests' stamp: 'IgorStasenko 8/6/2013 18:11'!
testFreshViewPositionIsAtStart
	"layout should answer text position from visual position"
	self assert: view layout startPosition equals: text startPosition! !

!TxAthensLayoutTest methodsFor: 'tests' stamp: 'IgorStasenko 8/8/2013 17:57'!
testLayoutShouldComputeExtent
	"text is not empty, so layout should be not empty either"
	self assert: view layout extent x isZero not.
	self assert: view layout extent y isZero not.
	
! !

!TxAthensLayoutTest methodsFor: 'tests' stamp: 'IgorStasenko 8/5/2013 17:21'!
testSettingViewExtent
	"layout should answer text position from visual position"
	
	
	view extent:100@100.
	
	self assert: view extent equals:100@100! !

TestCase subclass: #TxMultilineSmallTextLayoutTest
	instanceVariableNames: 'view1 view2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-Athens'!

!TxMultilineSmallTextLayoutTest methodsFor: 'instance-creation' stamp: 'IgorStasenko 8/8/2013 17:44'!
newText
	| text |
	text := TxModel new.
	
	text endPosition insert: 
'1: Line 1
2: Line deux'.

	^ text! !

!TxMultilineSmallTextLayoutTest methodsFor: 'instance-creation' stamp: 'IgorStasenko 8/8/2013 17:47'!
newText: aString
	| text |
	
	text := TxModel new.
	text endPosition insert:  aString.
	^ text! !

!TxMultilineSmallTextLayoutTest methodsFor: 'running' stamp: 'IgorStasenko 8/8/2013 17:58'!
setUp

	| text |
	
	text := self newText: 
'1: Line 1
2: Line2'.
	
	view1 := TxAthensLayoutView on: text extent: 100@10000.
	
	text := self newText: 
'1: Line 1
2: Line2
3: Line3'.

	view2 := TxAthensLayoutView on: text extent: 100@10000.

! !

!TxMultilineSmallTextLayoutTest methodsFor: 'tests' stamp: 'IgorStasenko 8/8/2013 17:58'!
testAddingLineShouldIncreaseLayoutHeight
 

	self assert: (view1 layout extent y < view2 layout extent y)! !

!TxMultilineSmallTextLayoutTest methodsFor: 'tests' stamp: 'IgorStasenko 8/8/2013 17:54'!
testLayoutExtentHeightShouldNotBeZero

	self assert: (view1 layout extent y ~= 0)! !

!TxMultilineSmallTextLayoutTest methodsFor: 'tests' stamp: 'IgorStasenko 8/8/2013 18:11'!
testView1LayoutShouldHaveTwoLines

	self assert: view1 layout lines size equals: 2.
	! !

!TxMultilineSmallTextLayoutTest methodsFor: 'tests' stamp: 'IgorStasenko 8/8/2013 18:12'!
testView2LayoutShouldHaveThreeLines

	self assert: view2 layout lines size equals: 3.
	! !

TestCase subclass: #TxOneLineTextLayoutTest
	instanceVariableNames: 'view1 view2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-Athens'!

!TxOneLineTextLayoutTest methodsFor: 'instance-creation' stamp: 'IgorStasenko 8/8/2013 18:03'!
newText: aString
	| text |
	
	text := TxModel new.
	text endPosition insert:  aString.
	^ text! !

!TxOneLineTextLayoutTest methodsFor: 'running' stamp: 'IgorStasenko 8/8/2013 18:02'!
setUp

	| text |
	
	text := self newText: '1'.
	
	view1 := TxAthensLayoutView on: text extent: 1000@10000.
	
	text := self newText: '12'.

	view2 := TxAthensLayoutView on: text extent: 1000@10000.

! !

!TxOneLineTextLayoutTest methodsFor: 'tests' stamp: 'IgorStasenko 8/8/2013 18:10'!
testLayoutShouldHaveOneLine

	self assert: view1 layout lines size equals: 1.
	self assert: view2 layout lines size equals: 1.
	! !

!TxOneLineTextLayoutTest methodsFor: 'tests' stamp: 'IgorStasenko 8/8/2013 18:03'!
testLineSizeIncreasesLayoutExtent
 

	self assert: (view1 layout extent x< view2 layout extent x)! !
